#include <iostream>
#include <bits/stdc++.h>

using namespace std;

int main()
{
    int n;
    cin>>n;
    vector <int> delioci;
    for(int i=1;i*i<n;i++){
        if(n%i==0)
            vector.push_back(i);
        if(i!=n/i)
            vector.push_back(n/i);
    }}
    sort(delioci.begin(),delioci.end());
    int xorg=0;
    for(int d:delioci)
        xorg=xorg^d;
    cout<<xorg;
    for(int d:divisors){
        int xor=0;
        for(int j=1;j*j<d;j++){
            if(d%j==0){
                xor=xor^j;
                if(j!=d/j)
                    xor=xor^(d/j);
            }

        cout<<xor<<" "<<;
    }

    return 0;
}